function [s] = svd_mesh(toadj, do_adj)

    [U, S, V] = svd(toadj);
    svd_stain = U(:,1);
    
    s = svd_stain;
    
    if nargin > 1,
        if do_adj > 0,
            
            med_stain = median(toadj, 2);
            [val, min_stain] = min(med_stain);
            [val, max_stain] = max(med_stain);
            
            if svd_stain(min_stain) < svd_stain(max_stain),
                s = adj_mesh(svd_stain, 0, 255);
            else
                s = adj_mesh(svd_stain, 255, 0);
            end
        end
    end

end



function [adj] = adj_mesh(toadj, rmin, rmax)

    if min(toadj) == max(toadj),
        adj = repmat(255, [length(toadj), 1]);
        return;
    end

    to_r = range(toadj);
    to_min = min(toadj);
    adj_r = abs(rmax - rmin);
    
    adj = abs(rmin - ((toadj - to_min) .* (adj_r / to_r)));
    adj(adj > 255) = 255;
end